
// Keypad module connections
char  keypadPort at PORTD;
// LCD module connections
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;


unsigned int temp_res;
int key,cnt=0,puntos=10,pot,temp,i;
char txt[7];

void interrupt() {
    //TMR0 = 227;                // Timer TMR0 is returned its initial value
    //INTCON = 0x20;            // Bit T0IE is set, bit T0IF is cleared
    TMR0 = 233;                // Timer TMR0 is returned its initial value
    INTCON = 0x20;
     asm{BSF STATUS,7}
    PORTB.F6=~PORTB.F6;
    PORTB.F7=~PORTB.F7;
    if(PORTB.F6==1 && PORTB.F7==0)
    {
    PORTC.F0=0;
    PORTC.F1=1;
    PORTC.F2=1;
    PORTC.F3=1;
    PORTC.F4=1;
    PORTC.F5=1;
    PORTC.F6=0;
    }
    else
    {
    PORTC.F0=0;
    PORTC.F1=1;
    PORTC.F2=1;
    PORTC.F3=1;
    PORTC.F4=1;
    PORTC.F5=0;
    PORTC.F6=1;
    }
}
char teclado(char key){
switch(key){
      case  1: return 1; break; // 1        // Uncomment this block for keypad4x4
      case  2: return 2; break; // 2
      case  3: return 3; break; // 3
      case  4: return 10; break; // A
      case  5: return 4; break; // 4
      case  6: return 5; break; // 5
      case  7: return 6; break; // 6
      case  8: return 10; break; // B
      case  9: return 7; break; // 7
      case 10: return 8; break; // 8
      case 11: return 9; break; // 9
      case 12: return 10; break; // C
      case 13: return 10; break; // *
      case 14: return 10; break; // 0
      case 15: return 10; break; // # = 6; break; // 6
      case 16: return 10; break; // D
      }
}

void main() {


  ANSEL=0x20;              // Configure AN5 pin as analog
  ANSELH=0;                 // Configure other AN pins as digital I/O
  C1ON_bit=0;               // Disable comparators
  C2ON_bit=0;
  Lcd_Init();
  asm{BCF STATUS,7}
  ADC_Init();
  Keypad_Init();

  TRISB=0;                 // PORTD is output
  /*asm{
        bsf PORTB,7
        bcf PORTB,6
  } */
  //TRISD=0XFF;
  TRISE=0b1001;
  TRISA=0;
  TRISC=0x80;
  PORTA=0;
  PORTC.F0=0;
    PORTC.F1=1;
    PORTC.F2=1;
    PORTC.F3=1;
    PORTC.F4=1;
    PORTC.F5=0;
    PORTC.F6=1;
  PORTB.F6=0;
  PORTB.F7=1 ;
 Lcd_Cmd(_LCD_CLEAR);               // Clear display
 Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
     temp_res=0;
do{

        OPTION_REG = 0x84;        // Prescaler is assigned to timer TMR0
        TMR0 = 200;                // Timer T0 counts from  to 255
        INTCON = 0xA0;            // Enable interrupt TMR0
        PORTB.F6=0;
       PORTB.F7=1 ;
       Lcd_Cmd(_LCD_CLEAR);
       //delay_ms(5);
       asm{BcF STATUS,7}
        Lcd_Out(1, 1, "-- Menu Principal --");
         asm{BcF STATUS,7}
       Lcd_Out(2, 1, "Eliga una opcion");

       Lcd_Out(3, 1, "1.- Jugar Adivina! ");
                      asm{BcF STATUS,7}
       Lcd_Out(4, 1, "2.- Iniciar ADC");               asm{BcF STATUS,7}
       do{

       key=keypad_key_click();
       }while(!key);
       Lcd_Cmd(_LCD_CLEAR);
       INTCON=0;
       PORTB.F6=1;
       PORTB.F7=1 ;
       key=teclado(key);
       PORTC=0x00;
       if(key==1)
       {
        //key=0;
        cnt=1;
        puntos=10;



        do{
               Lcd_Cmd(_LCD_CLEAR);
                       asm{BCF STATUS,7}
                       Lcd_Out(2,1,"Adivina el Numero!");  asm{BCF STATUS,7}

                       Lcd_Out(3,1,"ingresa tu eleccion");  asm{BSF STATUS,7}
              do{
                  key=Keypad_Key_Click();             // Store key code in key variable
                  if(cnt==9)
                  {
                          cnt=1;
                  }
                  else
                          cnt++;

              } while (!key);
              key=teclado(key);

               if(key==cnt)
               {
                         Lcd_Cmd(_LCD_CLEAR);
                         puntos=puntos+5;
                         intToStr(puntos,txt);
                         asm{BcF STATUS,7}
                         Lcd_Out(3,1,"Total Puntos: "); asm{BsF STATUS,7}
                         lcd_out_cp(txt);  asm{BcF STATUS,7}
                         lcd_out(1,1,"Ud. acertoo!");asm{BSF STATUS,7}
                         delay_ms(1500);

                }
               else
               {
                         Lcd_Cmd(_LCD_CLEAR);
                         puntos--;
                         wordToStr(puntos,txt);
                         asm{BsF STATUS,7}
                         Lcd_Out(3,1,"Total Puntos: ");
                          asm{BsF STATUS,7}
                         lcd_out_cp(txt); asm{BsF STATUS,7}
                         lcd_out(1,1,"Ud. NO acertoo!");
                         delay_ms(1500);
                          if(puntos<=0)
                          {
                                         asm{BsF STATUS,7}
                                      Lcd_Cmd(_LCD_CLEAR);
                                                     asm{BsF STATUS,7}
                                      Lcd_Out(3,1,"El juego termino");  asm{BsF STATUS,7}
                                      Lcd_Out(2,1,"Puntos Agotados");
                                      delay_ms(2500);
                                      lcd_Cmd(_LCD_CLEAR);
                                      key=0;
                          }

                }
          }while(puntos>0);



       }
           else
           {
               if(key==2)
               {

                     PORTC=0x00;

                      Lcd_Cmd(_LCD_CLEAR);

                      do {
                           asm{BsF STATUS,7}
                          lcd_cmd(_LCD_CLEAR);   asm{BSF STATUS,7}
                          Lcd_Out(2, 1,"Numero Binario ADC"); asm{BsF STATUS,7}
                          Lcd_Out(3, 1,"Rep. Decimal:");

                          temp_res = ADC_Read(5);   // Get 10-bit results of AD conversion
                          PORTA = temp_res;         // Send lower 8 bits to PORTA
                          if( (temp_res>=256 && temp_res<=511)|| (temp_res>=768 && temp_res<=1023))
                          PORTE.F1 = 1;    // Send 2 most significant bits to RC1, RC0
                          else
                          PORTE.F1 = 0;
                          if( (temp_res>=512 && temp_res<=1023))
                          PORTE.F2 = 1;    // Send 2 most significant bits to RC1, RC0
                          else
                          PORTE.F2 = 0;
                          WordToStr(temp_res,txt);
                          Lcd_Out_cp(txt);
                          LCD_CMD(_LCD_RETURN_HOME);
                                 temp=temp_res;
                                 for(i=0;i<11;i++)
                                 {
                                     pot=(temp%2);
                                     IntTostr(pot,txt);    asm{BsF STATUS,7}
                                     Lcd_Out(4,(14-i),txt); asm{BsF STATUS,7}
                                     temp=temp/2;
                                 }
                          } while(portc.f7==1);
                          while(portc.f7==0){}
                          temp_res=0;
                          PORTA=0;
                          Lcd_Cmd(_LCD_CLEAR);


               }
               else
               {
                     LCD_CMD(_LCD_CLEAR);
                     delay_ms(5);
                     asm{BCF STATUS,7}
                     Lcd_Out(2,1,"ingreso invalido"); asm{BSF STATUS,7}
                     delay_ms(1000);
                }
           }


}while(1);
}
